Subject: Re: OpenPIC warnings on P1022RDK AMP configuration

From: Scott Wood <[email-masked]>
Date: Tue, 10 Jan 2012 15:02:01 -0600

On 01/10/2012 02:43 AM, Arshad, Farrukh wrote:
> Change kernel configuration as per following to fix this warning.
> 
>  
> 
> Disable Kernel Options -> Support for enabling/disabling CPUs
> 
> Disable Kernel Options -> Distribute interrupts on all CPUs by default
> 
>  
> 
> Regards,
> 
> Farrukh Arshad
> 
>  
> 
> *From:*Arshad, Farrukh
> *Sent:* Friday, December 23, 2011 11:18 AM
> *To:* [email-masked]
> *Subject:* OpenPIC warnings on P1022RDK AMP configuration
> 
>  
> 
> Greetings All
> 
>  
> 
> I am running dual linux on P1022RDK in AMP configuration. My memory
> partitioning is as below
> 
>  
> 
> ---------------------------------------------------------------------
> 
> Core                      | Base Address  |    Size                 |
> 
> --------------------------|---------------|-------------------------|
> 
> Core 0 (MEL RT Kernel)    | 0x0000,0000   | 0x0C00,0000 - 192 (MB)  |
> 
> Core 1 (LTIB Kernel)      |0x0C00,0000    | 0x1000,0000 - 256 (MB)  |
> 
> MCAPI - Shared Mem        | 0x1C00,0000   | 0x0400,0000 - 64 
> (MB)  |            
> 
> ---------------------------------------------------------------------
> 
>  
> 
> My kernel command lines are for both cores
> 
>  
> 
> setenv core0bootargs root=/dev/mmcblk0p3 rootdelay=5 rw mem=192M
> 
> setenv core1bootargs root=/dev/nfs nfsroot=<serverip>:/<rootfs> ip=dhcp
> mem=256M
> 
>  
> 
> I have also partitioned my hardware among both cores and supplied
> appropriate “protected-sources” in mpic node of both DTS files. The
> problem is, I receive following warning continuously only on Core 0
> console, but Core 1 is running smooth. In following warnings source irqs
> are mostly which I have assigned to Core 1, but they are present in Core
> 0 mpic node “protected-sources” list, then why I am getting these messages.
> 
>  
> 
> [    6.219204] __ratelimit: 5796 callbacks suppressed
> 
> [    6.223996]  OpenPIC  : Got protected source 30 !
> 
> [    7.005809]  OpenPIC  : Got protected source 30 !
> 
> [    8.005906]  OpenPIC  : Got protected source 30 !
> 
> [    8.433053]  OpenPIC  : Got protected source 29 !
> 
> [    8.437942]  OpenPIC  : Got protected source 30 !
> 
> [    8.443101]  OpenPIC  : Got protected source 30 !
> 
> [    8.448428]  OpenPIC  : Got protected source 30 !
> 
>  
> 
> Any thoughts ?

Does each dtb have the correct CPU number, both from the command line
boot cpu flag and in the CPU node?

Do both device trees have pic-no-reset in the mpic node?

If neither of those are the issue, start dumping the relevant MPIC
interrupt destination registers, and tracethe code where they're
supposed to be set up.  Also make sure that no interrupts are enabled
when Linux receives control from U-Boot.

-Scott